;*************************************************************************
;       Assembler directives

.486
.model flat,stdcall
option casemap:none

;*************************************************************************
;       Include file

include A2U.inc

.code

;*************************************************************************
;       Common AddIn Procedures

OutputString proc uses ebx lpString:DWORD

	mov		ebx,lpProc
	push	0
	call	[ebx].ADDINPROCS.lpSetOutputTab
	push	TRUE
	call	[ebx].ADDINPROCS.lpShowOutput
	push	lpString
	call	[ebx].ADDINPROCS.lpTextOutput
	ret
OutputString endp

UpdateMenu proc uses esi edi hMnu:HMENU
LOCAL	mii:MENUITEMINFO
;LOCAL	buffer[MAX_PATH]:BYTE
LOCAL	tb:TBBUTTON

	mov		mii.cbSize,sizeof MENUITEMINFO
	mov		mii.fMask,MIIM_SUBMENU
	mov		esi,lpHandles
	invoke GetMenuItemInfo,[esi].ADDINHANDLES.hMenu,IDM_TOOLS,FALSE,addr mii
	invoke AppendMenu,mii.hSubMenu,MF_STRING,IDAddIn,offset szMenuName

;	mov		mii.fMask, MIIM_DATA or MIIM_ID or MIIM_SUBMENU or MIIM_TYPE
;	lea		eax,buffer
;	mov		mii.dwTypeData,eax
;	mov		mii.cch,sizeof buffer
;	invoke GetMenuItemInfo,[esi].ADDINHANDLES.hMenu,IDAddIn,FALSE,addr mii
	
	mov	edi,[esi].ADDINHANDLES.hTbrEdit1
	; TBBUTTON <0,IDAddIn,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0,0>
	invoke ImageList_GetImageCount,[esi].ADDINHANDLES.hImlTbr 
	dec eax
	lea ecx, tb
	mov [ecx].TBBUTTON.iBitmap,eax
	mov eax, IDAddIn
	mov [ecx].TBBUTTON.idCommand, eax
	mov [ecx].TBBUTTON.fsState, TBSTATE_ENABLED
	mov [ecx].TBBUTTON.fsStyle, TBSTYLE_BUTTON
	mov [ecx].TBBUTTON._wPad1, 0
	mov [ecx].TBBUTTON.dwData, 0
	mov [ecx].TBBUTTON.iString, 0
	invoke SendMessage,edi,TB_ADDBUTTONS,1,addr tb
	ret
UpdateMenu endp

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
    mov    eax, hInst
    mov    hInstance, eax
    mov    eax, TRUE
    ret
DllEntry Endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
InstallAddin proc uses ebx esi hWin:DWORD

	mov	ebx,hWin
;    invoke InitCommonControls
    invoke LoadBitmap, hInstance, 2000
    mov    hBmp, eax
    invoke LoadIcon, hInstance, 1
    mov    hIcon, eax

	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;
	mov	lpHandles,eax
	
	mov esi, [eax].ADDINHANDLES.hImlTbr
    ;ImageList_AddMasked
    invoke ImageList_AddMasked,esi,hBmp,0FFFFFFh
    invoke DeleteObject,hBmp

;	;Get handles of codecomplete tooltip
;	mov		edx,[eax].ADDINHANDLES.hTT
;	mov		hTT,edx

	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov	lpProc,eax

	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0
	mov	lpData,eax

	; Allocate a new menu id
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDAddIn,eax
	mov		hook.hook1,HOOK_COMMAND or HOOK_MENUUPDATE
	xor		eax,eax
	mov		hook.hook2,eax
	mov		hook.hook3,eax
	mov		hook.hook4,eax
	mov		eax,offset hook
	ret

InstallAddin Endp

; Export this proc (it is autoexported if MakeDef is enabled with option 2)
AddinProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other DLL's from

	mov	eax, uMsg
	.if eax == AIM_COMMAND
		mov eax,wParam
		movzx edx,ax
		shr eax, 16
		.IF edx == IDAddIn && eax == BN_CLICKED
			mov eax,lpHandles
			mov eax,[eax].ADDINHANDLES.hWnd
			invoke CreateDialogParam,hInstance,IDD_DIALOG1,eax,addr DlgProc,NULL
			mov eax,TRUE
			ret
		.ENDIF
	.elseif eax==AIM_MENUUPDATE
		invoke UpdateMenu,wParam
	.endif
	mov eax,FALSE
	ret
AddinProc Endp


DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

    mov     eax,uMsg
    .if eax==WM_INITDIALOG
        invoke SendMessage,hWin,WM_SETICON,ICON_SMALL,hIcon
        invoke GetDlgItem, hWin, IDE_ANSI
        mov    hANSI, eax
        invoke GetDlgItem, hWin, IDE_UNICODE
        mov    hUNIC, eax

        invoke GetDlgItemText, hWin, IDE_NAME, addr szName, 128
        mov  nLnStr, eax
        invoke fnRegQuery
        invoke SetDlgItemText, hWin, IDE_NAME, addr szName
       
    .elseif eax==WM_COMMAND
        .if wParam==IDB_TRANS
            invoke SendMessage, hUNIC, EM_SETSEL, 0, -1
            invoke SendMessage, hUNIC, WM_CLEAR, 0, 0
            invoke GetDlgItemText, hWin, IDE_ANSI, addr szANSI, 80h
            .if !eax
                ret		;    - 
            .endif
            call ParseString
            mov ecx, 10
            mul ecx
            mov sizeUbuf, eax
            invoke GlobalAlloc, GMEM_ZEROINIT, eax
            mov    szUNIC, eax
            mov    ebx, MB_PRECOMPOSED
            invoke MultiByteToWideChar, CP_ACP, ebx, addr szANSI, -1, addr szUNIC, sizeUbuf
            dec    eax
            mov    [hLenght], eax

            invoke GetDlgItemText, hWin, IDE_NAME, addr szName, 128
            mov    ecx, eax
            lea    eax, offset szName
            .if ecx<24
            	mov edx, 24
            	sub edx, ecx
            	shr edx, 2
            .endif
            .while edx
                mov byte ptr[eax+ecx], 09h
                inc ecx
                dec edx
            .endw
            mov    byte ptr[eax+ecx], 0

            invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr szComment
            invoke GetDlgItemText, hWin, IDE_ANSI, addr szANSI, 80h
            invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr szANSI
            invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr CRLF
            invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr szName
            invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr szDW

            xor    ecx, ecx
            lea    esi, offset szUNIC
            ;mov    esi, eax
            xor    eax, eax

            .while ecx<[hLenght]

                push   ecx
                xor    edx, edx
                mov    dx,  word ptr[esi+ecx*2]
                invoke wsprintf, addr szOut, addr szFormat, edx

                invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr szOut

                pop    ecx
                push   ecx
                inc    ecx
                mov    eax, ecx
                xor    edx, edx
                mov    ecx, 8
                div    ecx
                .if    !edx
                    invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr CRLF
                    invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr szNewStr
                .else
                    invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr szZpt
                .endif
                pop    ecx
                inc    ecx
            .endw

            invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr szEnd
            invoke SendMessage, hUNIC, EM_REPLACESEL, 0, addr CRLF
            invoke GlobalFree, szUNIC
        .elseif wParam==IDB_EDIT
            invoke GetDlgItemText, hWin, IDE_UNICODE, addr szUNIC, 1536
            mov    eax, lpHandles
            invoke SendMessage, [eax].ADDINHANDLES.hEdt, EM_REPLACESEL, 1, addr szUNIC
            ;invoke fnRegSet, hWin
        .elseif wParam==IDB_OUT
            invoke FuncOutStrToRad, hWin
            ;invoke fnRegSet, hWin
        .elseif wParam==IDB_EXIT
            jmp    ExitDlg
        .endif
    .elseif eax==WM_CLOSE
ExitDlg:
        invoke fnRegSet, hWin
        invoke EndDialog,hWin,0
    .else
        mov     eax,FALSE
        ret
    .endif
    mov     eax,TRUE
    ret
DlgProc endp

FuncOutStrToRad proc hDlg:HWND
    ;call   clrOutput
    invoke GetDlgItemText, hDlg, IDE_UNICODE, addr szUNIC, 1536
    invoke OutputString, addr szUNIC
    ret
FuncOutStrToRad endp

; ------------------------------------------------------------
fnRegQuery    proc
LOCAL hRegK:DWORD
LOCAL szBuf[128]:BYTE

    invoke RegCreateKeyEx, HKEY_CURRENT_USER, addr lpSubKey, 0, 0, 0, \
            KEY_WRITE or KEY_READ, 0, addr hRegK, addr lpdwDisp
    mov    lpcbData, 128
    
    invoke RegQueryValueEx, hRegK, addr szIDE_NAME, 0, addr lpType, addr lpRegData, addr lpcbData
    .if !eax
        invoke lstrcpy, addr szName, addr lpRegData
        invoke lstrlen, addr szName
        mov    nLnStr, eax
    .endif
    invoke fnFindLowerUnderline, addr szName, nLnStr
    .if !eax
        invoke lstrcat, addr szName, T("_")
    .endif
    invoke fnIncNumber, hRegK
    invoke wsprintf, addr szBuf, T("%d"), NameInc
    invoke lstrcat, addr szName, addr szBuf
    invoke RegCloseKey, hRegK
    ret
fnRegQuery endp

fnFindLowerUnderline proc lpStr:DWORD, nLen:DWORD

    cld
    mov ecx, nLen 
    mov edi, lpStr
    mov al, '_'
    repne scasb
    mov eax, 0
    jne ExitFalse
    mov eax, nLen
    sub eax, ecx
    mov edi, lpStr
    mov byte ptr[edi+eax],0
ExitFalse:
    ret
fnFindLowerUnderline endp

fnIncNumber proc hRegN:DWORD

    mov    lpcbData, 4
    invoke RegQueryValueEx, hRegN, addr szNameVal, 0, addr lpType, addr lpRegData, addr lpcbData
    .if !eax
        push   dword ptr[lpRegData]
        pop    NameInc
        inc    NameInc
    .elseif
        mov    NameInc, 0
    .endif
    mov    lpcbData, 4
    push   NameInc
    pop    dword ptr[lpRegData]
    invoke RegSetValueEx, hRegN, addr szNameVal, 0, REG_DWORD, addr lpRegData, lpcbData
    ret
fnIncNumber endp

fnRegSet proc hWin:DWORD
LOCAL hRegK:DWORD
;LOCAL szBuf[128]:BYTE

    invoke RegCreateKeyEx, HKEY_CURRENT_USER, addr lpSubKey, 0, 0, 0, \
            KEY_WRITE or KEY_READ, 0, addr hRegK, addr lpdwDisp
    
    invoke GetDlgItemText, hWin, IDE_NAME, addr szName, 128
    mov    nLnStr, eax
    mov    lpcbData, eax
    invoke fnFindLowerUnderline, addr szName, nLnStr
    invoke RegSetValueEx, hRegK, addr szIDE_NAME, 0, REG_SZ, addr szName, lpcbData
   
    invoke RegCloseKey, hRegK
    ret

fnRegSet endp

ParseString proc 
;	                NL(LF)        \n	0Ah
;	          NT            \t	09h
;	            VT            \v	0Bh
;	                     BS            \b	08h
;	                   CR            \r	0Dh
;	                    \             \\	5Ch
;	  ()     '             \'	27h
	mov edx, eax
	lea esi, szANSI
	lea edi, szANSI
	xor ecx, ecx
	.while ecx<edx
		mov al, byte ptr[esi+ecx]
		.if al=='\'
			mov al, byte ptr[esi+ecx+1]
			.if al=='t'
				mov byte ptr[edi], 09h
			.elseif al=='v'
				mov byte ptr[edi], 0Bh
			.elseif al=='b'
				mov byte ptr[edi], 08h			
			.elseif al=='n'
				mov byte ptr[edi], 0Dh
				inc edi
				mov byte ptr[edi], 0Ah
			.elseif al=='r'
				mov byte ptr[edi], 0Dh
				inc edi
				mov byte ptr[edi], 0Ah
			.else
				dec ecx
			.endif
			;inc edx
			inc ecx
		.else
			mov byte ptr[edi], al
		.endif
		
		inc ecx
		inc edi
	.endw
	mov byte ptr[edi], 0
	sub edi,esi
	mov eax, edi
	ret
ParseString endp

End DllEntry
